//
//  AppDelegate.swift
//  ShanYanAppStoreDemo
//
//  Created by wanglijun on 2019/8/7.
//  Copyright © 2019 wanglijun. All rights reserved.
//

import UIKit
import IQKeyboardManagerSwift
import CL_ShanYanSDK

let appID = "<#your appid#>"//需和BundleID对应


@UIApplicationMain

class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?

    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {

        // Override point for customization after application launch.
        IQKeyboardManager.shared.enable = true

        let blyConfig = BuglyConfig()
        blyConfig.channel = "AppStore"
        blyConfig.version = "2.3.1.1"
        Bugly.start(withAppId: "e4f2fbe528",config: blyConfig)
        
        let initStartTime: TimeInterval = Date().timeIntervalSince1970
        CLShanYanSDKManager.initWithAppId(appID) { (complete) in
            let error = complete.error as NSError?
            UserDefaults.standard.set(Date().timeIntervalSince1970 - initStartTime, forKey: "sdkInitCost")
            UserDefaults.standard.synchronize()
            
            guard error == nil else{

                print(complete.code,complete.message,complete.error)

                let msg = String(complete.code)
                let message = complete.message ?? ""
                let errorString = String(format: "%@", error?.userInfo ?? "")

                print(#function,#line,msg,message,errorString)
                return
            }
            print(#function,#line,complete.code,complete.message ?? "")
        }
        
        let preLoginStartTime = Date().timeIntervalSince1970
        CLShanYanSDKManager.preGetPhonenumber { (completeResult) in
            UserDefaults.standard.set(Date().timeIntervalSince1970 - preLoginStartTime, forKey: "preLoginCost")
            UserDefaults.standard.synchronize()
        }

        return true
    }

    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}

